import argparse
from datetime import datetime, timedelta, date
import glob

parser = argparse.ArgumentParser(description='Test if files in a given range are on the server')
parser.add_argument("-path", "--path", help = "Specify the path, e.g. /mic/L0444-001/duo/MDA01", required = True, default = "")
parser.add_argument("-data", "--data", help = "Specify the data name, e.g. 002 or 06 or Nsp", required = True, default = "")

parser.add_argument("-start_date", "--start_date", help = "Specify the start date : year-month-day, e.g. 2017-11-15", required = True, default = "")
parser.add_argument("-start_time", "--start_time", help = "Specify the start time : hour-minute, e.g. 11-10", required = True, default = "")
parser.add_argument("-end_date", "--end_date", help = "Specify the end date : year-month-day, e.g. 2017-11-17", required = True, default = "")
parser.add_argument("-end_time", "--end_time", help = "Specify the end time : hour-minute, e.g. 09-15", required = True, default = "")

args = parser.parse_args()

path = args.path
data_name = args.data
start_date = args.start_date
end_date = args.end_date
start_time = args.start_time
end_time = args.end_time

first_year =  int(start_date.split("-")[0])
first_month = int(start_date.split("-")[1])
first_day = int(start_date.split("-")[2])

last_year = int(end_date.split("-")[0])
last_month = int(end_date.split("-")[1])
last_day = int(end_date.split("-")[2])

first_hour =  int(start_time.split("-")[0])
first_minute = int(start_time.split("-")[1])

last_hour = int(end_time.split("-")[0])
last_minute = int(end_time.split("-")[1])

start = datetime(first_year, first_month, first_day, first_hour, first_minute, 0)
end = datetime(last_year, last_month, last_day, last_hour, last_minute, 0)

list_of_dates_to_check = []
list_of_files_to_check = []
list_of_missing_files = []


while start <= end:
        list_of_dates_to_check.append(start)
        start += timedelta(minutes=5)
	

for time in list_of_dates_to_check:
    file_time =  (str(time).split()[1].replace(':','-'))
    file_date =  (str(time).split()[0] + '_' + file_time)
    full_file_name = path  +  file_date + "." + data_name
    list_of_files_to_check.append(full_file_name)

all_files = glob.glob(path + "/*." + data_name)

for file_to_check in list_of_files_to_check:
    if file_to_check in all_files :
	next
    else:
#       print (file_to_check)
#       print ("File is missing")
       list_of_missing_files.append(file_to_check)


print ("List of missing files")
print (list_of_missing_files)
print ("Number of missing files")
print (len(list_of_missing_files))

